#include "knn.h"


/** constructor of the Knn class **/
Knn::Knn(Dataset *t,int K)
{
    dt = t;
    paramK=K;
    computeDistanceArray();
}


/** Epistrefei apostasi metaxy x1,x2 **/
double  Knn::getDistance(Data &x1,Data &x2)
{
    double sum =0.0;
    for(int i=0;i<x1.size();i++)
        sum+=(x1[i]-x2[i])*(x1[i]-x2[i]);//pow(x1[i]-x2[i],2.0);
    return sqrt(sum);
}

/** ypologizei ton pinaka apostaseon **/
void Knn::computeDistanceArray()
{
    distance.resize(dt->count());
    for(int i=0;i<dt->count();i++)
    {
        distance[i].resize(dt->count());
        for(int j=0;j<dt->count();j++)
        {
            Data x1=dt->getXPoint(i);
            Data x2=dt->getXPoint(j);
            distance[i][j]=getDistance(x1,x2);
        }
    }
}


//auti i methodos epistrefei tous K -geitones enos
//neou simeiou X

vector<int> Knn::getNeighbours(Data &x)
{
    vector<int> m;
    vector<int> index;

    index.resize(dt->count());
    for(int i=0;i<index.size();i++)
        index[i]=i;

    //autos einai o pinakas apostaseon apo ola ta simeia tou dataset
    vector<double> distanceFromPoint;
    distanceFromPoint.resize(dt->count());
    for(int i=0;i<distanceFromPoint.size();i++)
    {
        Data xx=dt->getXPoint(i);
        distanceFromPoint[i]=getDistance(x,xx);
    }

    for(int i=0;i<distanceFromPoint.size();i++)
    {
        for(int j=0;j<distanceFromPoint.size()-1;j++)
        {
            if(distanceFromPoint[j]>distanceFromPoint[j+1])
            {

                double d=distanceFromPoint[j];
                distanceFromPoint[j]=distanceFromPoint[j+1];
                distanceFromPoint[j+1]=d;

                //taxinomo mazi me tis apostaseis kai ton pinaka index
                int t=index[j];
                index[j]=index[j+1];
                index[j+1]=t;
            }
        }
    }
    for(int i=0;i<paramK;i++)
    {
        m.push_back(index[i]);
    }

    return m;
}



//Epistrefei tin katigoria enos agnostou protypou

double Knn::getClass(Data &x)
{
    vector<int> votes;

    //kano resize to votes oses einai oi klaseis
    Data patternClass=dt->getPatternClass();
    votes.resize(patternClass.size());

    //arxikopoio tis psifous se 0 se kathe  klasi
    for(int i=0;i<votes.size();i++) votes[i]=0;

    //pairno tous geitones
    vector<int> nn=getNeighbours(x);
    printf("geitones={");
    for(int i=0;i<nn.size();i++)
        printf(" %d ",nn[i]);
    printf("}\n");
    //psifizoun oi geitones
    for(int i=0;i<nn.size();i++)
    {
        double mclass=dt->getYPoint(nn[i]);
        for(int j=0;j<patternClass.size();j++)
        {
            if(fabs(mclass-patternClass[j])<1e-5)
            {
                votes[j]++;
                break;
            }
        }
    }


    //brisko poia katigoria exei tis pio polles psifous
    //kai tin epistrefo
    int maxVotes=votes[0];
    int maxIndex=0;
    for(int i=0;i<votes.size();i++)
    {
        if(votes[i]>maxVotes)
        {
            maxVotes=votes[i];
            maxIndex=i;
        }
    }

    printf("Found class  for pattern x is %.5lf\n",patternClass[maxIndex]);
    return patternClass[maxIndex];
}
/** epistrefei lista me tous K-kontinoteroys geitones tou
 * protypou stin thesi pos

 epistrefei theseis!!!

**/
vector<int> Knn::getNeighbours(int pos)
{
    vector<int> m;
    vector<int> index;
    Data distanceOfPoint=distance[pos];
    index.resize(dt->count());
    for(int i=0;i<index.size();i++)
        index[i]=i;
    //index[0]=0,index[1]=1, index[2]=2
    for(int i=0;i<distanceOfPoint.size();i++)
    {
        for(int j=0;j<distanceOfPoint.size()-1;j++)
        {
            if(distance[pos][j]>distance[pos][j+1])
            {
                if(i==j) continue;
                double d=distance[pos][j];
                distance[pos][j]=distance[pos][j+1];
                distance[pos][j+1]=d;

                //taxinomo mazi me tis apostaseis kai ton pinaka index
                int t=index[j];
                index[j]=index[j+1];
                index[j+1]=t;
            }
        }
    }
    for(int i=0;i<paramK;i++)
    {
        m.push_back(index[i]);
    }

    return m;
}

//Euresi tis klasis gia ena simeio pos
//tha kratiso ekeini tin klasi me tis pio polles psifous
double Knn::getClass(int pos)
{
    vector<int> votes;

    //kano resize to votes oses einai oi klaseis
    Data patternClass=dt->getPatternClass();
    votes.resize(patternClass.size());

    //arxikopoio tis psifous se 0 se kathe  klasi
    for(int i=0;i<votes.size();i++) votes[i]=0;

    //pairno tous geitones
    vector<int> nn=getNeighbours(pos);
    printf("geitones[%d]={",pos);
    for(int i=0;i<nn.size();i++)
        printf(" %d ",nn[i]);
    printf("}\n");
    //psifizoun oi geitones
    for(int i=0;i<nn.size();i++)
    {
        double mclass=dt->getYPoint(nn[i]);
        for(int j=0;j<patternClass.size();j++)
        {
            if(fabs(mclass-patternClass[j])<1e-5)
            {
                votes[j]++;
                break;
            }
        }
    }


    //brisko poia katigoria exei tis pio polles psifous
    //kai tin epistrefo
    int maxVotes=votes[0];
    int maxIndex=0;
    for(int i=0;i<votes.size();i++)
    {
        if(votes[i]>maxVotes)
        {
            maxVotes=votes[i];
            maxIndex=i;
        }
    }

    printf("Found class  for pattern %d is %.5lf\n",pos,patternClass[maxIndex]);
    return patternClass[maxIndex];
}

double Knn::getValue(Data &x)
{
    vector<int> nn=getNeighbours(x);
    double sum=0;
    for(int i=0;i<nn.size();i++)
    {
        double y = dt->getYPoint(nn[i]);
        sum+=y;
    }
    return sum/nn.size();
}

/** euresi synartisiakis timis **/
double Knn::getValue(int pos)
{
   vector<int> nn=getNeighbours(pos);
   double sum=0.0;
   for(int i=0;i<nn.size();i++)
   {
       double y=dt->getYPoint(nn[i]);
       sum+=y;
   }
   return sum/nn.size();
}

/** euresi classification error **/
double  Knn::getClassError()
{
    double sum=0;
    for(int i=0;i<dt->count();i++)
    {
        double y1=dt->getClass(i);
        double y2=getClass(i);
        if(fabs(y1-y2)>1e-5)
            sum+=1.0;
    }
    return sum * 100.0/dt->count();
}

/** euresi regression error **/
double  Knn::getTestError()
{
    double sum=0;
    for(int i=0;i<dt->count();i++)
    {
        double y1=dt->getYPoint(i);
        double y2=getValue(i);
        sum+=pow(y1-y2,2.0);
    }
    return sum;
}

Knn::~Knn()
{

}
